/* {{{ preamble
 * regtools.c
 *
 * Contains a bunch of things that should be elsewhere.
 *
 * Authors:	Sean Loaring
 *		Petter Nordahl-Hagen
 *
 * Copyright (c) 2005-2006 Sean Loaring
 * Copyright (c) 1997-2004 Petter Nordahl-Hagen
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * TODO: move the parts of this file that are still in use to where they should be and delete
 *
 }}} */

#include "hivetools.h"
#include "sam.h"
#include "../misc/globals.h"
#include "../lib/ntreg.h" //TODO: shouldn't be here

#include <ctype.h>
#include <openssl/des.h>

int H_SAM = -1;
int H_SYS = -1;
int H_SEC = -1;
int H_SOF = -1;
//
///* Array of loaded hives */
//struct hive *hive[MAX_HIVES+1];
//int no_hives = 0;
//char *val_types[REG_MAX+1];
//int dirty = 0;

int rm_debug = 0;

//int max_sam_lock = 0;

//TODO: This should all be in sam.h/c
/* Check if hive is SAM, and if it is, extract some
 * global policy information from it, like lockout counts etc
 */

//void check_get_samdata(void) // {{{
//{
//	struct accountdb_F *f;
//	struct keyval *v;
//
//	if (H_SAM >= 0) {
//
//		/* Get users F value */
//		DIE("I don't work anymore, replace below.");
//		/*
//		v = get_val2buf(hive[H_SAM], NULL, 0, ACCOUNTDB_F_PATH, REG_BINARY);
//		if (!v) {
//			printf("Login counts data not found in SAM\n");
//			return;
//		}
//		*/
//
//		f = (struct accountdb_F *)&v->data;
//		max_sam_lock = f->locklimit;
//
//		if( gverbose ) {
//			printf("\n* SAM policy limits:\n");
//			printf("Failed logins before lockout is: %d\n",max_sam_lock);
//			printf("Minimum password length        : %d\n",f->minpwlen);
//			printf("Password history count         : %d\n",f->minpwlen);
//		}
//	}
//} // }}}

/* Crypto-stuff & support for what we'll do in the V-value */

#if 0
// this stuff is now in sam.h/c
void make_lanmpw(char *p, char *lm, int len) // {{{ zero lanman passwd, replace with uppercase supplied password
{
	int i;

	for (i=0; i < 15; i++) lm[i] = 0;
	for (i=0; i < len; i++) lm[i] = toupper(p[i]);
} // }}}
void str_to_key(unsigned char *str,unsigned char *key) // {{{ Convert a 7 byte array into an 8 byte des key with odd parity.
{
	int i;

	key[0] = str[0]>>1;
	key[1] = ((str[0]&0x01)<<6) | (str[1]>>2);
	key[2] = ((str[1]&0x03)<<5) | (str[2]>>3);
	key[3] = ((str[2]&0x07)<<4) | (str[3]>>4);
	key[4] = ((str[3]&0x0F)<<3) | (str[4]>>5);
	key[5] = ((str[4]&0x1F)<<2) | (str[5]>>6);
	key[6] = ((str[5]&0x3F)<<1) | (str[6]>>7);
	key[7] = str[6]&0x7F;
	for (i=0;i<8;i++) {
		key[i] = (key[i]<<1);
	}
	DES_set_odd_parity((des_cblock *)key);
} // }}}
void sid_to_key1(unsigned long sid,unsigned char deskey[8]) // {{{ Function to convert the RID to the first decrypt key.
{
	unsigned char s[7];

	s[0] = (unsigned char)(sid & 0xFF);
	s[1] = (unsigned char)((sid>>8) & 0xFF);
	s[2] = (unsigned char)((sid>>16) & 0xFF);
	s[3] = (unsigned char)((sid>>24) & 0xFF);
	s[4] = s[0];
	s[5] = s[1];
	s[6] = s[2];

	str_to_key(s,deskey);
} // }}}
void sid_to_key2(unsigned long sid,unsigned char deskey[8]) // {{{ Function to convert the RID to the second decrypt key.
{
	unsigned char s[7];
	
	s[0] = (unsigned char)((sid>>24) & 0xFF);
	s[1] = (unsigned char)(sid & 0xFF);
	s[2] = (unsigned char)((sid>>8) & 0xFF);
	s[3] = (unsigned char)((sid>>16) & 0xFF);
	s[4] = s[0];
	s[5] = s[1];
	s[6] = s[2];

	str_to_key(s,deskey);
} // }}}
void E1(uchar *k, uchar *d, uchar *out) // {{{ DES encrypt, for LANMAN 
{
	des_key_schedule ks;
	des_cblock deskey;

	str_to_key(k,(uchar *)deskey);
#ifdef __FreeBSD__
	des_set_key(&deskey,ks);
#else /* __FreeBsd__ */
	des_set_key((des_cblock *)deskey,ks);
#endif /* __FreeBsd__ */
	des_ecb_encrypt((des_cblock *)d,(des_cblock *)out, ks, DES_ENCRYPT);
} // }}}

#endif

// vim600: set foldlevel=0 foldmethod=marker:
