/* {{{ preamble
 * regtools.h
 *
 * Contains a bunch of things that should be elsewhere.
 *
 * Authors:	Sean Loaring
 *		Petter Nordahl-Hagen
 *
 * Copyright (c) 2005-2006 Sean Loaring
 * Copyright (c) 1997-2004 Petter Nordahl-Hagen
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * TODO: move the parts of this file that are still in use to where they should be and delete
 *
 }}} */

#ifndef REGTOOLS_H
#define REGTOOLS_H
#include <sys/types.h>
//#include "hivelib/ntreg.h"
#include "../lib/libhive.h"

#define uchar u_char
#define MD4Init MD4_Init
#define MD4Update MD4_Update
#define MD4Final MD4_Final

#define MAX_HIVES 10


/* Array of loaded hives */
extern struct hive *hive[];
extern int no_hives;
extern char *val_types[];

extern int dirty;
//extern int max_sam_lock;


/* Icky icky... globals used to refer to hives, will be
 * set when loading, so that hives can be loaded in any order
 */

extern int H_SAM;
extern int H_SYS;
extern int H_SEC;
extern int H_SOF;

// if the registry loaded is a sam then extract some information
void check_get_samdata(void);

/* Zero out string for lanman passwd, then uppercase
 * the supplied password and put it in here */
void make_lanmpw(char *p, char *lm, int len);

/*
 * Convert a 7 byte array into an 8 byte des key with odd parity.
 */
void str_to_key(unsigned char *str,unsigned char *key);

/*
 * Function to convert the RID to the first decrypt key.
 */
void sid_to_key1(unsigned long sid,unsigned char deskey[8]);

/*
 * Function to convert the RID to the second decrypt key.
 */
void sid_to_key2(unsigned long sid,unsigned char deskey[8]);


/* DES encrypt, for LANMAN */
void E1(uchar *k, uchar *d, uchar *out);

#endif

// vim600: set foldlevel=0 foldmethod=marker:
