/* {{{ preamble
 * defines.h
 *
 * Defines identification strings for different structures stored in the
 * registry.  Also defines files access modes.
 *
 * Authors:	Sean Loaring
 *		Petter Nordahl-Hagen
 *
 * Copyright (c) 2005-2006 Sean Loaring
 * Copyright (c) 1997-2004 Petter Nordahl-Hagen
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * TODO: this file should be hacked up and the bits placed in other header files
 *
 }}} */

#include <sys/types.h>

#ifndef DEFINES_H
#define DEFINES_H

#define SZ_MAX     4096       /* Max unicode strlen before we truncate */

#define MTYPE 			unsigned short

#define ID_HBIN 0x6E696268
#define ID_REGF 0x66676572

#ifndef ulong
#define ulong unsigned long
#endif

/* {{{ Record ID Defines */
/* record IDs for scanning a broken registry */
/*  - but what about the ones that aren't broken? */
/*    - there is no such registry :D */

#define KEY_ROOT   0x2c         /* Type ID of ROOT key node */
#define KEY_UTF16  0x00       /* A key with a UTF16 name */
#define KEY_NORMAL 0x20       /* Normal nk key */

#define ID_REGF_HEADER 		0x6667
#define ID_HBIN_PAGE		0x6E69
#define ID_SK_KEY 		0x6b73
#define ID_LF_KEY 		0x666c
#define ID_LH_KEY 		0x686c
#define ID_LI_KEY 		0x696c
#define ID_RI_KEY 		0x6972
#define ID_VK_KEY 		0x6b76
#define ID_NK_KEY		0x6b6e
/* }}} */
// {{{ Hive access mode defines
#define HMODE_RW        0
#define HMODE_RO        0x1
#define HMODE_OPEN      0x2
#define HMODE_DIRTY     0x4
#define HMODE_NOALLOC   0x8
#define HMODE_VERBOSE 0x1000
// }}}
#endif

// vim600: set foldlevel=0 foldmethod=marker:
