/* {{{ preamble
 * winerr.c
 *
 * Emulates only the most absolutely necessary parts of the win32 error system.
 *
 * Authors:	Sean Loaring
 *
 * Copyright (c) 2005-2006 Sean Loaring
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 }}} */

#include "winerr.h"
#include "wintypes.h"
#include "string.h"
#include "../misc/tools.h"
#include "../misc/uerr.h"

#ifdef WITH_WIN32_PASSTHROUGH
#include <windows.h>
#endif

char *win_errstr[] =  // {{{
{
        "This is the error you get when there was no error.",
        "Buffer too small.  Need more buffer.",
        "There are no more idems.",
        "Generic error - please write real error.",
        "Not found.",
        "Open failed."
}; // }}}
DWORD rlFormatMessage( DWORD dwFlags, LPCVOID lpSource, DWORD dwMessageId, DWORD dwLanguageId, LPTSTR lpBuffer, DWORD nSize, va_list* Arguments) // {{{
{
	/* Oh.  My.  God.  WTF was the person who came up with this API
	 * function smoking? */

	/* I'm implementing this as quickly and half-assedly as possible.  If
	 * you need missing features then you'll have to write them yourself */


#ifdef WITH_WIN32_PASSTHROUGH
DWORD r = FormatMessage( dwFlags, lpSource, dwMessageId, dwLanguageId, lpBuffer, nSize, Arguments );
//WARN("FormatMessage returns: %s", *(void**)lpBuffer );
//hexdump( lpBuffer, 0, nSize, 1 );
return r;
#endif

	ASSERT( dwFlags == (rlFORMAT_MESSAGE_ALLOCATE_BUFFER | rlFORMAT_MESSAGE_FROM_SYSTEM),
			"FormatMessage() doesn't implement whatever it is that you are trying to do." );

	ASSERT( dwMessageId < MAX_WIN_ERROR, "FormatMessage(): Got a dwMessageId I don't know about." );

	*((void**)lpBuffer) = (void*)F_MALLOC( strlen( win_errstr[dwMessageId] ) + 1 );

	strcpy( *(void**)lpBuffer, win_errstr[dwMessageId] );

	return strlen( lpBuffer ) + 1;
} // }}}
char *winstrerror( DWORD myerrno ) // {{{ returns statically allocated error message
{
	void *p;

	static vbuf *vb = NULL;
	if(!vb)vb = vbuf_alloc(100);

	rlFormatMessage( rlFORMAT_MESSAGE_ALLOCATE_BUFFER | rlFORMAT_MESSAGE_FROM_SYSTEM,
			NULL,
			myerrno,
			0,
			(LPTSTR)&p,
			0,
			NULL );

	if( p ) {
		vbuf_strset( vb, p );
		rlLocalFree( p );
	}
	else {
		vbuf_strset( vb, "UNKNOWN ERROR.");
	}


	return vb->b;
} // }}}

// vim600: set foldlevel=0 foldmethod=marker:
